/* 
 *   $Id: setfn.c,v 1.8 2001/06/05 22:28:14 rross Exp $    
 *
 *   Copyright (C) 1997 University of Chicago. 
 *   See COPYRIGHT notice in top-level directory.
 */

#include "adio.h"

void ADIOI_SetFunctions(ADIO_File fd)
{
    /* NOTE: soon we want to get rid of this malloc and instead just point
     * straight to the appropriate table
     */
    fd->fns = (ADIOI_Fns *) ADIOI_Malloc(sizeof(ADIOI_Fns));
    switch(fd->file_system) {
    case ADIO_PFS:
#ifdef PFS	
	*(fd->fns) = ADIO_PFS_operations;
#else
	FPRINTF(stderr, "ADIOI_SetFunctions: ROMIO has not been configured to use the PFS file system\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
#endif
	break;

    case ADIO_PIOFS:
#ifdef PIOFS	
	*(fd->fns) = ADIO_PIOFS_operations;
#else
	FPRINTF(stderr, "ADIOI_SetFunctions: ROMIO has not been configured to use the PIOFS file system\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
#endif
	break;

    case ADIO_UFS:
#ifdef UFS	
	*(fd->fns) = ADIO_UFS_operations;
#else
	FPRINTF(stderr, "ADIOI_SetFunctions: ROMIO has not been configured to use the UFS file system\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
#endif
	break;

    case ADIO_NTFS:
#ifdef NTFS
	*(fd->fns) = ADIO_NTFS_operations;
	/*
	fd->fns->ADIOI_xxx_Open = ADIOI_NTFS_Open;
	fd->fns->ADIOI_xxx_ReadContig = ADIOI_NTFS_ReadContig;
	fd->fns->ADIOI_xxx_WriteContig = ADIOI_NTFS_WriteContig;
	fd->fns->ADIOI_xxx_ReadStridedColl = ADIOI_NTFS_ReadStridedColl;
	fd->fns->ADIOI_xxx_WriteStridedColl = ADIOI_NTFS_WriteStridedColl;
	fd->fns->ADIOI_xxx_SeekIndividual = ADIOI_NTFS_SeekIndividual;
	fd->fns->ADIOI_xxx_Fcntl = ADIOI_NTFS_Fcntl;
	fd->fns->ADIOI_xxx_SetInfo = ADIOI_NTFS_SetInfo;
	fd->fns->ADIOI_xxx_ReadStrided = ADIOI_NTFS_ReadStrided;
	fd->fns->ADIOI_xxx_WriteStrided = ADIOI_NTFS_WriteStrided;
	fd->fns->ADIOI_xxx_Close = ADIOI_NTFS_Close;
	fd->fns->ADIOI_xxx_IreadContig = ADIOI_NTFS_IreadContig;
	fd->fns->ADIOI_xxx_IwriteContig = ADIOI_NTFS_IwriteContig;
	fd->fns->ADIOI_xxx_ReadDone = ADIOI_NTFS_ReadDone;
	fd->fns->ADIOI_xxx_WriteDone = ADIOI_NTFS_WriteDone;
	fd->fns->ADIOI_xxx_ReadComplete = ADIOI_NTFS_ReadComplete;
	fd->fns->ADIOI_xxx_WriteComplete = ADIOI_NTFS_WriteComplete;
	fd->fns->ADIOI_xxx_IreadStrided = ADIOI_NTFS_IreadStrided;
	fd->fns->ADIOI_xxx_IwriteStrided = ADIOI_NTFS_IwriteStrided;
	fd->fns->ADIOI_xxx_Flush = ADIOI_NTFS_Flush;
	fd->fns->ADIOI_xxx_Resize = ADIOI_NTFS_Resize;
	fd->fns->ADIOI_xxx_Delete = ADIOI_GEN_Delete;
	*/
#else
	FPRINTF(stderr, "ADIOI_SetFunctions: ROMIO has not been configured to use the NTFS file system\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
#endif
	break;

    case ADIO_NFS:
#ifdef NFS	
	*(fd->fns) = ADIO_NFS_operations;
#else
	FPRINTF(stderr, "ADIOI_SetFunctions: ROMIO has not been configured to use the NFS file system\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
#endif
	break;

    case ADIO_HFS:
#ifdef HFS	
	*(fd->fns) = ADIO_HFS_operations;
#else
	FPRINTF(stderr, "ADIOI_SetFunctions: ROMIO has not been configured to use the HFS file system\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
#endif
	break;

    case ADIO_XFS:
#ifdef XFS	
	*(fd->fns) = ADIO_XFS_operations;
#else
	FPRINTF(stderr, "ADIOI_SetFunctions: ROMIO has not been configured to use the XFS file system\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
#endif
	break;

    case ADIO_SFS:
#ifdef SFS	
	*(fd->fns) = ADIO_SFS_operations;
#else
	FPRINTF(stderr, "ADIOI_SetFunctions: ROMIO has not been configured to use the SFS file system\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
#endif
	break;

    case ADIO_PVFS:
#ifdef ROMIO_PVFS
	*(fd->fns) = ADIO_PVFS_operations;
#else
	FPRINTF(stderr, "ADIOI_SetFunctions: ROMIO has not been configured to use the PVFS file system\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
#endif
	break;

    default:
	FPRINTF(stderr, "ADIOI_SetFunctions: Unsupported file system type\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
	break;
    }
}
